SystemOrganization addCategory: #'Orange-Resource'!

ALComponentResource subclass: #ORBasicAuthResource
	instanceVariableNames: 'caller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Resource'!

!ORBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/10/2015 16:09'!
authorized: result locator: aLocator
	| root cookie url |
	root := component rematerialize.
	"[root noteDispatch]
		on: ALUserStipulation
		do: [:stipulation | stipulation component user: result user]."
	url := aLocator urlForResource: root asResource.
	cookie := ALCookie name: 'auth' value: result token.
	cookie path: '/'.
	"^ ALResponse created
		location: 'http://www.abc.com';
		setCookie: cookie;
		yourself"
	^ (ALResponse seeOther: url)
			setCookie: cookie; 
			yourself! !

!ORBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/3/2015 16:08'!
denied
	^ ALResponse status: 401 reason: 'Authentication failed'! !

!ORBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/10/2015 15:46'!
handleGet: aRequest locator: aLocator
	| request result authstring |
	(aRequest authorization isNil)
		ifTrue: [^self respondWithChallenge]
		ifFalse: [
	authstring := (aRequest authorization copyAfter: Character space) base64Decoded.
	request := ALAuthenticationRequest withUsername:  (authstring copyUpTo: $:)   password: (authstring copyAfter: $:).
	result := request signal].
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]
			! !

!ORBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/3/2015 16:15'!
respondWithChallenge
	^ALResponse unauthorized
		wwwAuthenticate: 'Basic Realm = "My Server"';
			yourself! !

ALHtmlResource subclass: #ORUploadResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Resource'!

!ORUploadResource commentStamp: 'chc 6/16/2015 12:26' prior: 0!
Workspace notes:

	docroot := FSLocator imageDirectory.
	ALDirectoryScanner scan: docroot into: locator.
	docroot allEntries second basename

	stream := (FSLocator imageDirectory / 'package-cache' / 'fooforall.txt') writeStream.
	stream nextPutAll: 'Hello FooForAll'.
	stream close. !

!ORUploadResource methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2015 15:58'!
handlePut: aRequest locator: aLocator
	| stream |
	" get the name from the request" 
	" place the name at the end of the FSLocator path" 
	" direct the 'stream contents' to the disk" 
	" done. I think" 
	aRequest readEntityWith: [ :in |  stream := (FSLocator imageDirectory / 'package-cache' / 'fooforall.txt') writeStream.
									stream nextPutAll: in.					
								      stream close. ].

	"isValidMczName: string
	^ string isString 
		and: [ string isEmpty not
			and: [ (string endsWith: '.mcz')
				and: [ (string includes: $/) not ] ] ]"

	"| name |
	name := request url allButFirst.
	((self isValidMczName: name) and: [ (self directory fileExists: name) not ]) 
		ifTrue: [
			self directory newFileNamed: name do: [ :file | | response |
				file binary.
				request streamFrom: request stream to: file size: request contentLength progress: nil.
				request sendCreated ] ]
		ifFalse: [ request sendBadRequest ]"

	! !

ALResource subclass: #ORAuthenticationResource
	instanceVariableNames: 'caller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Resource'!

!ORAuthenticationResource class methodsFor: 'as yet unclassified' stamp: 'cwp 12/24/2012 08:25'!
component: aComponent
	^ self basicNew initializeWithComponent: aComponent! !

!ORAuthenticationResource methodsFor: 'as yet unclassified' stamp: 'chc 3/17/2015 14:51'!
authorized: result locator: aLocator
	| root cookie url |
	root := caller rematerialize.
	[root noteDispatch]
		on: ALUserStipulation
		do: [:stipulation | stipulation component auth: true ].
	url := aLocator urlForResource: root asResource.
	cookie := ALCookie name: 'auth' value: result token.
	cookie path: '/'.
	"^ ALResponse created
		location: 'http://localhost:8624' , url;
		setCookie: cookie;
		yourself"
	^ (ALResponse seeOther: url)
		setCookie: cookie;
		date: DateAndTime now;
		keepAlive: 'timeout=10, max=20';
		yourself! !

!ORAuthenticationResource methodsFor: 'as yet unclassified' stamp: 'chc 3/11/2015 14:17'!
denied
	^ ALResponse status: 401 reason: 'Authentication failed'! !

!ORAuthenticationResource methodsFor: 'as yet unclassified' stamp: 'chc 2/10/2015 15:35'!
handleGet: aRequest locator: aLocator
	| request result authstring |
	(aRequest authorization isNil)
		ifTrue: [^self respondWithChallenge]
		ifFalse: [
	authstring := (aRequest authorization copyAfter: Character space) base64Decoded.
	request := ALAuthenticationRequest withUsername:  (authstring copyUpTo: $:)   password: (authstring copyAfter: $:).
	result := request signal].
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]
			! !

!ORAuthenticationResource methodsFor: 'as yet unclassified' stamp: 'chc 2/17/2015 16:30'!
handlePost: aRequest locator: aLocator
	| request result |
	request := ALAuthenticationRequest new.
	aRequest readEntityWith: 
		[:in | ALJsonParser  parse: in for: request].
	result := request signal.
	^ (result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [self denied]! !

!ORAuthenticationResource methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2012 11:40'!
initializeWithComponent: aComponent
	self initialize.
	caller := aComponent.
	! !
